<template>
  <v-container>
    <!-- Titulo General -->
    <v-row>
      <v-col cols="12">
        <v-card class="text-center" color="yellow">Galeria de libros</v-card>
        <!-- Carousel -->
        <v-carousel
          cycle
          height="250"
          hide-delimiter-background
          show-arrows-on-hover
        >
          <v-carousel-item v-for="(slide, i) in libros" :key="i" height="100%">
            <v-sheet :color="colors[i]" height="100%">
              <v-row class="fill-height" align="center" justify="center">
                <v-col class="mx-auto">
                  <div class="display-5 text-center">
                    <v-img
                      :src="slide.img"
                      width="100"
                      height="150"
                      class="mx-auto"
                    ></v-img>
                    Autor {{ slide.author }} - Titulo {{ slide.title }}
                  </div>
                </v-col>
              </v-row>
            </v-sheet>
          </v-carousel-item>
        </v-carousel>
      </v-col>
    </v-row>
    <v-row>
      <!-- Filtro por titulo -->
      <v-col xs="12" sm="12" md="8">
        <v-row>
          <v-col xs="12" sm="12" md="6">
            <v-card color="blue mx-auto" dark min-width="250" height="100">
              <v-card-text>
                <v-text-field
                  label="Filtrar por Titulo"
                  type="text"
                  v-model="filtroTitulo"
                />
              </v-card-text>
            </v-card>
          </v-col>

          <!-- Filtro por Autor -->
          <v-col xs="12" sm="12" md="6">
            <v-card color="pink accent-1" dark min-width="250" height="100">
              <v-card-text>
                <v-text-field
                  label="Filtrar por Autor"
                  type="text"
                  v-model="filtroAutor"
                />
              </v-card-text>
            </v-card>
          </v-col>
        </v-row>

        <v-row>
          <!-- Cargando -->
          <v-col cols="12" v-if="cargando" class="text-center">
            <v-progress-circular
              indeterminate
              color="primary"
            ></v-progress-circular>
          </v-col>
          <!-- Mostramos libros -->
          <v-col
            v-else
            sm="12"
            md="4"
            xl="4"
            v-for="(libro, index) in obtenerLibrosFiltrados"
            :key="index"
          >
            <book :libro="libro" @sumoLibro="agregarLibCarro"></book>
          </v-col>
        </v-row>
      </v-col>
      <!-- Carrito de compras -->
      <v-col xs="12" sm="12" md="4">
        <cart :carrito="carrito"></cart>

        <!-- notificacion -->
        <v-alert v-show="notificar" text type="success" class="mt-2">
          ¡<strong>Libro</strong> agregado al carrito con
          <strong>exito</strong>!
        </v-alert>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import Book from "./Book";
import Cart from "./Cart";

export default {
  name: "Gallery",
  mounted() {
    this.cargando = true;
    fetch("http://commons.showvlad.com/books.json")
      .then((res) => res.json())
      .then((data) => {
        this.cargando = false;
        data.forEach((element) => {
          this.libros.push(element);
        });
      });
  },
  data() {
    return {
      libros: [],
      carrito: [],
      filtroAutor: "",
      filtroTitulo: "",
      notificar: null,
      cargando: false,
      colors: [
        "indigo",
        "warning",
        "pink darken-2",
        "red lighten-1",
        "deep-purple accent-4",
      ],
    };
  },
  components: {
    Book,
    Cart,
  },
  watch: {
    notificar() {
      if (this.notificar) {
        setTimeout(() => (this.notificar = null), 1500);
      }
    },
  },
  computed: {
    obtenerLibrosFiltrados() {
      let regAutor = new RegExp(this.filtroAutor, "i");
      let regTitulo = new RegExp(this.filtroTitulo, "i");

      return this.libros.filter(
        (libro) => regAutor.test(libro.author) && regTitulo.test(libro.title)
      );
    },
  },
  methods: {
    agregarLibCarro(libro) {
      let posLibro = -1;

      if (this.carrito.length > 0) {
        posLibro = this.carrito.findIndex(
          (items) => items.titulo == libro.title
        );
      }

      if (posLibro !== -1) {
        this.carrito[parseInt(posLibro)].cantidad++;
      } else {
        this.carrito.push({
          titulo: libro.title,
          precio: libro.price,
          imagen: libro.img,
          cantidad: 1,
        });
      }

      this.setNotificar();
    },
    setNotificar() {
      this.notificar = true;
    },
  },
};
</script>
<style></style>
